; SOI 2015 Creativity Task 'Bazaar'.
;
; Sample bot in x86 assembly.
; Contact: sebastian@soi.ch
; nasm -f elf bot.asm; gcc -o bot bot.o -m32

extern	scanf
extern	printf
extern	exit
extern  fflush
extern  srand
extern	rand
extern	malloc
global  main

section .data
	config: db "%d %d %d "	
	in:	db "%d", 0	; format string for io.
	out:	db "%d", 0xA, 0

section .bss
        n:	resd	1	; game configuration.
	a:	resd	1
        d:	resd	1
	g:	resd	1
	pls:	resd	1
	bids:	resd	1	
        bid:	resd	1	
	
section	.text

init:				; initialize the bot.
	push 0
	call srand
	add esp, 4		; fix random seed.

	push g
	push d
	push a
	push n
	push config
	call scanf
	add esp, 0x14		; read game configuration.

	mov eax, [n]		; allocate memory to keep track of all players.
	shl eax, 2
	push eax
	call malloc
	add esp, 4
	mov [pls], eax

	mov eax, [d]		; allocate memory for the bids.
	shl eax, 2
	push eax
	call malloc
	add esp, 4
	mov [bids], eax
	ret

play:				; play a single auction.
	push ebx
	push edi

	mov edi, [bids]
	mov ecx, [d]
	xor eax, eax
	rep stosd		; set bids array to zero.

	mov edi, [pls]
	mov ecx, [n]
	mov eax, [g]
	rep stosd		; every player starts with the same amount of gold.
	
	mov ebx, [g]
distribute_gold:		; distribute the available gold randomly.
	call rand
	mov ecx, [d]
	cdq
	idiv ecx
	shl edx, 2
	add edx, [bids]
	mov eax, [edx]
	inc eax
	mov [edx], eax
	
	dec ebx
	jnz distribute_gold

	mov ebx, [d]
play_auction:			; play the auction.
	mov edx, ebx
	dec edx
	shl edx, 2
	add edx, [bids]
	mov edx, [edx]
	push edx		; place the bid
	push out
	call printf
	add esp, 8
	push 0
	call fflush
	add esp, 4
				; keep track of every player's gold.
	mov edi, [pls]
	mov eax, [edi]
	sub eax, edx		; substract own bid.
	mov [edi], eax
	mov edx, [n]
	dec edx
update_players:
	add edi, 4

	push edx
	push bid		; read other player's bid.
	push in
	call scanf
	add esp, 8

	mov eax, [edi]		; update other player's gold.
	sub eax, [bid]
	mov [edi], eax
	
	pop edx
	dec edx
	jnz update_players
	
	dec ebx
	jnz play_auction

	pop edi
	pop ebx
	ret
	
main:				; entry.
	call init		; initialize the bot.

	mov ebx, [a]		; play all auctions.
next_auction:
	call play		; play an auction.
	dec ebx
	jnz next_auction
	
	push 0
	call exit		; exit.
