//  SOI 2015 Creativity Task 'Bazaar'
//
//  Sample bot in C.
//  contact: sebastian@soi.ch

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


//  Game configuration.
int n, a, d, g, *players, *bids;

void init() {
  //  Initialize the bot.
  srand(0);
  scanf("%d %d %d %d", &n, &a, &d, &g);
  players = calloc(n, sizeof(int));
  bids = calloc(d, sizeof(int));
}

void playAuction() {
  //  Play a single auction.
  int i, round, bid;

  //  Distribute the available gold randomly.
  memset(bids, 0, sizeof(int)*d);
  for (i=0; i<g; i++) ++bids[rand()%d];

  //  Initialize players.
  for (i=0; i<n; i++) players[i] = g;

  //  Play the auction.
  for (round=0; round<d; round++) {
    //  Place bid.
    printf("%d\n", bids[round]);
    fflush(stdout);

    //  Keep track of every player's gold.
    players[0] -= bids[round];
    for (i=1; i<n; i++) {
      scanf("%d", &bid);
      players[i] -= bid;
    }
  }
}

int main() {
  //  Allocate and initialize bot.
  init();

  //  Participate in the auctions.
  while (a--) playAuction();

  //  Release.
  free(players); free(bids);

  return 0;
}
