//  SOI 2015 Creativity Task 'Bazaar'.
//
//  Sample bot in Go.
//  contact: sebastian@soi.ch

package main

import (
	"fmt"
	"math/rand"
)

//  Game configuration.
var (
	n, a, d, g    int
	bids, players []int
)

func alloc() {
	//  Initialize the bot.
	fmt.Scanf("%d %d %d %d", &n, &a, &d, &g)
	bids = make([]int, d)
	players = make([]int, g)
}

func playAuction() {
	//  Play a single auction.
	for i := range bids {
		bids[i] = 0
	}
	for i := range players {
		players[i] = g
	}

	//  Distribute the available gold randomly.
	for coin := 0; coin < g; coin++ {
		bids[rand.Intn(d)] += 1
	}

	//  Play the auction.
	for round := 0; round < d; round++ {
		//  Place bid.
		fmt.Printf("%d\n", bids[round])

		//  Keep track of every player's gold.
		players[0] -= bids[round]
		for i := 1; i < n; i++ {
			var bid int
			fmt.Scanf("%d", &bid)
			players[i] -= bid
		}
	}
}

func main() {
	//  Initialize the bot.
	alloc()

	//  Play the auctions.
	for auction := 0; auction < a; auction++ {
		playAuction()
	}
}
