//  SOI 2015 Creativity Task 'Bazaar'.
//
//  Sample bot in Objective C.
//  contact: sebastian@soi.ch

#include <stdlib.h>
#import <Foundation/Foundation.h>


@interface Bot : NSObject {
    // Game configuration.
    int n, a, d, g, *players, *bids;
}

- (id)init;
- (void)dealloc;

- (void)playAuction;
- (void)play;

@end


@implementation Bot

- (id)init {
    // Initialize the bot.
    self = [super init];
    scanf("%d %d %d %d", &n, &a, &d, &g);
    players = calloc(n, sizeof(int));
    bids = calloc(d, sizeof(int));
    return self;
}

- (void)dealloc {
    free(players);
    free(bids);
}

- (void)playAuction {
    // Play a single auction.
    // Distribute the available gold randonly.
    memset(bids, 0, sizeof(int)*d);
    for (int i=0; i<g; i++) ++bids[rand()%d];
    
    // Initialize players.
    for (int i=0; i<n; i++) players[i] = g;
    
    // Play the auction.
    for (int round=0; round<d; round++) {
        // Place bid.
        printf("%d\n", bids[round]);
        fflush(stdout);
        
        // Keep track of every player's gold.
        players[0] -= bids[round];
        for (int i=1; i<n; i++) {
            int bid; scanf("%d", &bid);
            players[i] -= bid;
        }
    }
}

- (void)play {
    // Participate in the auctions.
    for (int auction=0; auction<a; auction++) [self playAuction];
}

@end


int main(int argc, const char * argv[]) {
    @autoreleasepool {
        // Initialize random seed.
        srand(0);
        
        Bot *player = [[Bot alloc] init];
        [player play];
    }
    return 0;
}
