//
//  SOI 2015 Creativity Task 'Bazaar'.
//
//  Sample bot in Swift.
//  Contact: sebastian@soi.ch
//

import Foundation

//  Read numbers from stdin.
func getInput() -> [Int] {
    var line: String = NSString(data: NSFileHandle.fileHandleWithStandardInput().availableData,
        encoding: NSUTF8StringEncoding)!
    return dropLast(line).componentsSeparatedByString(" ").map(){$0.toInt()!}
}

class Bot {
    //  Game state.
    private var n, a, d, g: Int
    
    init(n: Int, a: Int, d: Int, g: Int) {
        self.n = n; self.a = a; self.d = d; self.g = g
    }
    
    //  Play a single auction.
    private func playAuction() {
        var bids = [Int](count: d, repeatedValue: 0)
        var players = [Int](count: n, repeatedValue: g)
        
        // Distribute the available gold randomly.
        for _ in 0..<g {
            ++bids[Int(arc4random_uniform(UInt32(d)))]
        }
        
        // Play the auction.
        for bid in bids {
            // Place the bid.
            println(bid)
            fflush(stdout)
            
            //  Keep track of every player's gold.
            players[0] -= bid  //  Own player.
            for (p, v) in enumerate(getInput()) {
                players[p] -= v
            }
        }
    }
    
    //  Participate in the auctions.
    func play() {
        for _ in 0..<a {
            playAuction()
        }
    }
}

//  Read game configuration.
let config = getInput()
let bot = Bot(n: config[0], a: config[1], d: config[2], g: config[3])
bot.play()
